#ifndef id372857FBD20C4DD2A9EDDB3A167682AA
#define id372857FBD20C4DD2A9EDDB3A167682AA

#include "doorkeeper/implem/maptypes.hpp"
#include "doorkeeper/primitivetypes.hpp"
#include <cstdint>

namespace dk {
	template <typename T, uint32_t D>
	class BaseMapSource {
	public:
		typedef dk::Vector<dk::CoordinateScalarType, D> coords;
		BaseMapSource ( void ) = default;
		virtual ~BaseMapSource ( void ) noexcept = default;

		virtual void fetch ( std::vector<T>& parOut, const coords& parFrom, const coords& parTo ) = 0;
		virtual const coords& mapSize ( void ) const = 0;
		virtual MapTypes mapType ( void ) const = 0;
		virtual int layersCount ( void ) const = 0;
	};
} //namespace dk

#endif
